package com.move4mobile.smartpinsdkexample

import android.text.InputFilter
import android.text.Spanned
import java.util.regex.Pattern

class DecimalDigitsInputFilter(digitsBeforeZero: Int, digitsAfterZero: Int) : InputFilter {
    private val mPattern: Pattern = Pattern.compile("^-?[0-9]{0,$digitsBeforeZero}+([.|,][0-9]{0,$digitsAfterZero})?$")
    override fun filter(source: CharSequence, start: Int, end: Int, dest: Spanned, dstart: Int, dend: Int): CharSequence? {
        val price = StringBuilder(dest)
        if (dstart == dest.length) {
            price.append(source)
        } else {
            price.insert(dstart, source)
        }
        val matcher = mPattern.matcher(price)
        return if (!matcher.matches()) "" else null
    }

}