package com.move4mobile.smartpinsdkexample

import android.os.Bundle
import android.util.Log
import android.view.View
import androidx.appcompat.app.AppCompatActivity
import androidx.databinding.DataBindingUtil
import com.move4mobile.smartpinsdk.SmartPinManager
import com.move4mobile.smartpinsdk.interfaces.SPOrderListener
import com.move4mobile.smartpinsdk.models.SPError
import com.move4mobile.smartpinsdk.models.SPOrder
import com.move4mobile.smartpinsdkexample.databinding.ActivityOrderBinding
import kotlinx.android.synthetic.main.activity_order.*

class OrderActivity: AppCompatActivity() {

    companion object {
        const val ORDER_ID = "order_id"
    }

    private lateinit var binding: ActivityOrderBinding

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        binding = DataBindingUtil.setContentView(this, R.layout.activity_order)

        val orderId = intent.getLongExtra(ORDER_ID, 0)

        loader.visibility = View.VISIBLE
        content.visibility = View.GONE

        SmartPinManager.getOrder(orderId, object : SPOrderListener {
            override fun onOrderReceived(order: SPOrder) {
                showContent(order)
            }

            override fun onOrderFailed(error: SPError) {
                Log.d(SmartPinManager.TAG, "Order failed: ${error.message}")
            }
        })
    }

    fun showContent(order: SPOrder) {
        loader.visibility = View.GONE
        content.visibility = View.VISIBLE

        binding.amount = order.amount.toString()
        binding.type = order.type.toString()
        binding.method = order.paymentMethod
        binding.orderId = order.id.toString()
        binding.transactionId = order.transactionId
        binding.siteId = order.siteId
        binding.terminalId = order.terminalId
        binding.aid = order.aid
        binding.pan = order.pan
    }
}